<?php

namespace Unakit;

get_header();
?>
<main class="site__main error-404" role="main">

	<section class="page__content content-wrapper container">

		<header id="content" class="page__header main__header">
			<h1>
				<?php 
$unakit_title_404 = __( 'Error: 404 Not Found', 'unakit' );
echo  esc_html( $unakit_title_404 ) ;
?>
			</h1>
		</header>
		<?php 
?>
		<p>
			<?php 
echo  sprintf(
    // translators: %s: Link to homepage
    wp_kses_post( apply_filters( 'unakit_404_message', __( 'This page does not exist (anymore). Do you want to visit the <a href="%s">Homepage</a> instead?', 'unakit' ) ) ),
    esc_url( home_url( '/' ) )
) ;
?>
		</p>
		<?php 
get_search_form();
?>
		<p>
			<?php 

if ( isset( $_SERVER ) && isset( $_SERVER['REQUEST_URI'] ) ) {
    // Get user strings
    $unakit_user_req_uri = wp_unslash( esc_url_raw( $_SERVER['REQUEST_URI'] ) );
    $unakit_uri_words = preg_split( '/\\W+/', $unakit_user_req_uri );
    // Remove short words in long search terms
    if ( count( $unakit_uri_words ) > 2 ) {
        foreach ( $unakit_uri_words as $key => $word ) {
            if ( strlen( $word ) <= 2 ) {
                unset( $unakit_uri_words[$key] );
            }
        }
    }
    $unakit_uri_words_imploded = trim( implode( " ", $unakit_uri_words ) );
    // Show a few results
    $unakit_404_query = new \WP_Query( [
        's'              => esc_attr( $unakit_uri_words_imploded ),
        'orderby'        => 'relevance',
        'order'          => 'DESC',
        'posts_per_page' => 9,
    ] );
    
    if ( $unakit_404_query->have_posts() ) {
        echo  '<p>' . sprintf(
            /* translators: %s: search term derived from URL that caused 404 error */
            esc_html__( 'These pages might be related to "%s":', 'unakit' ),
            $unakit_uri_words_imploded
        ) . '</p>' ;
        while ( $unakit_404_query->have_posts() ) {
            $unakit_404_query->the_post();
            echo  '
							<div class="unakit_404__search_result">
								<a href="' . esc_url( get_the_permalink() ) . '">' . esc_html( get_the_title() ) . '</a>
							</div>' ;
        }
    }
    
    wp_reset_postdata();
}

?>
		</p>

	</section>

</main>

<?php 
get_footer();