(function ($) {

    function hexToRgb(hex, alpha = 1) {
        var result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
        return result ? {
            r: parseInt(result[1], 16),
            g: parseInt(result[2], 16),
            b: parseInt(result[3], 16),
            a: alpha
        } : {
            r: 255,
            g: 255,
            b: 255,
            a: 1
        };
    }


    wp.customize('blogname', function (value) {
        value.bind(function (newval) {
            $('.branding__text__title').html(newval);
        });
    });

    wp.customize('blogdescription', function (value) {
        value.bind(function (newval) {
            $('.branding__text__tagline').html(newval);
        });
    });

    wp.customize('round_logo', function (value) {
        value.bind(function (newval) {
            $('.branding__logo').css('transition', 'border-radius .25s ease-in-out');
            $('.branding__logo').css('border-radius', newval ? '1.25rem' : '0');
        });
    });

    wp.customize('hide_title', function (value) {
        value.bind(function (newval) {
            $('.branding__text__title').toggleClass('screen-reader-text', newval);
        });
    });

    wp.customize('hide_tagline', function (value) {
        value.bind(function (newval) {
            $('.branding__text__tagline').toggleClass('screen-reader-text', newval);
        });
    });


    wp.customize('body_background', function (value) {
        value.bind(function (newval) {
            $(':root').css('--background', newval);
        });
    });

    wp.customize('unakit_background_image', function (value) {
        value.bind(function (newval) {
            $(':root').css('--background_image', newval ? 'url(' + newval + ')' : 'none');
        });
    });

    wp.customize('unakit_background_repeat', function (value) {
        value.bind(function (newval) {
            $(':root').css('--background_repeat', newval);
        });
    });

    wp.customize('unakit_background_size', function (value) {
        value.bind(function (newval) {
            $(':root').css('--background_size', newval);
        });
    });

    wp.customize('unakit_background_position_x', function (value) {
        value.bind(function (newval) {
            $(':root').css('--background_position_x', newval);
        });
    });

    wp.customize('unakit_background_attachment', function (value) {
        value.bind(function (newval) {
            $(':root').css('--background_attachment', newval);
        });
    });

    wp.customize('header_background', function (value) {
        value.bind(function (newval) {
            var current = $(':root').css('--header_background');
            var rgba = current.match(/\d+/g);

            if (rgba.length === 4) {
                rgba[3] = 1;
            }

            newRgb = hexToRgb(newval, 1);
            newCol = `rgba(${newRgb.r}, ${newRgb.g}, ${newRgb.b}, ${rgba[3]})`;

            $(':root').css('--header_background', newCol);
        });
    });

    wp.customize('header_background_a', function (value) {
        value.bind(function (newval) {
            var current = $(':root').css('--header_background');
            var rgba = current.match(/\d+/g);

            newCol = `rgba(${rgba[0]}, ${rgba[1]}, ${rgba[2]}, ${newval})`;

            $(':root').css('--header_background', newCol);
        });
    });

    wp.customize('footer_background', function (value) {
        value.bind(function (newval) {
            $(':root').css('--footer_background', newval);
        });
    });


    wp.customize('font_heading', function (value) {
        value.bind(function (newval) {
            $(':root').css('--font_heading', newval);
        });
    });

    wp.customize('font_heading_weight', function (value) {
        value.bind(function (newval) {
            $(':root').css('--font_heading_weight', newval);
        });
    });

    wp.customize('font_heading_italic', function (value) {
        value.bind(function (newval) {
            $(':root').css('--font_heading_style', (newval == 1) ? 'italic' : 'normal');
        });
    });

    wp.customize('font_regular', function (value) {
        value.bind(function (newval) {
            $(':root').css('--font_regular', newval);
        });
    });

    wp.customize('font_regular_weight', function (value) {
        value.bind(function (newval) {
            $(':root').css('--font_regular_weight', newval);
        });
    });


    wp.customize('heading_color', function (value) {
        value.bind(function (newval) {
            $(':root').css('--heading_color', newval);
        });
    });

    wp.customize('text_color', function (value) {
        value.bind(function (newval) {
            $(':root').css('--text_color', newval);
        });
    });

    wp.customize('link_color', function (value) {
        value.bind(function (newval) {
            $(':root').css('--link_color', newval);
        });
    });

    wp.customize('header_text_color', function (value) {
        value.bind(function (newval) {
            $(':root').css('--header_text_color', newval);
        });
    });

    wp.customize('footer_heading_color', function (value) {
        value.bind(function (newval) {
            $(':root').css('--footer_heading_color', newval);
        });
    });

    wp.customize('footer_text_color', function (value) {
        value.bind(function (newval) {
            $(':root').css('--footer_text_color', newval);
        });
    });

    wp.customize('footer_link_color', function (value) {
        value.bind(function (newval) {
            $(':root').css('--footer_link_text_color', newval);
        });
    });


    wp.customize('header_height', function (value) {
        value.bind(function (newval) {
            $('.site__header__content').css('transition', 'min-height .25s ease-in-out');

            $(':root').css('--header_height', newval + 'rem');

            var header_is_fixed = $('.site__header').css('position') == 'fixed';
            $(':root').css('--header_overlap_height', header_is_fixed ? newval + 'rem' : '0');

        });
    });

    wp.customize('fixed_header', function (value) {
        value.bind(function (newval) {
            $('.site__header').css('position', newval ? 'fixed' : 'absolute');

            var header_height = $(':root').css('--header_height');
            $(':root').css('--header_overlap_height', newval ? header_height : '0');
        });
    });

    wp.customize('header_shadow', function (value) {
        value.bind(function (newval) {
            $('.site__header').css('transition', 'box-shadow .25s linear');
            $('.submenu').css('transition', 'box-shadow .25s linear');
            if (newval) {
                $('.site__header').css('box-shadow', '0 0 3rem .5rem rgba(0, 0, 0, .05)');
                $('.submenu').css('box-shadow', '0 0 3rem .5rem rgba(0, 0, 0, .05)');
            } else {
                $('.site__header').css('box-shadow', '0 0 3rem .5rem rgba(0, 0, 0, 0)');
                $('.submenu').css('box-shadow', '0 0 3rem .5rem rgba(0, 0, 0, 0)');
            }
        });
    });


    wp.customize('nav_style', function (value) {
        value.bind(function (newval) {
            if (newval && newval != '') {
                // remove current nav-style-... class
                $('.site__header__content').attr('class', function (i, c) {
                    return c && c.replace(/(^|\s)nav-style-\S+/g, '');
                });

                $('.site__header__content').addClass('nav-style-' + newval);
            }
        });
    });


    wp.customize('wide_footer', function (value) {
        value.bind(function (newval) {
            let footer = $('footer.site__footer > .site__footer__content');
            $(footer).css('transition', 'max-width .25s ease-in-out');
            $(footer).css('max-width', newval ? 'var(--container_width_wide)' : 'var(--container_width)')
        });
    });


    wp.customize('underline_links', function (value) {
        value.bind(function (newval) {
            $(':root').css('--link_decoration', newval ? 'underline' : 'none');
            $(':root').css('--link_decoration_highlight', newval ? 'none' : 'underline');
        });
    });

})(jQuery);